function [labels1,L,ctime,all_centers,W,Q]=main_seedseg(tem_img_rgb,splabels,xx_obj,yy_obj,xx_bak,yy_bak,method)
%% 
OMask = sparse(round(yy_obj),round(xx_obj),ones(1,length(xx_obj)),size(tem_img_rgb,1),size(tem_img_rgb,2));
OMask = (OMask-0.5)>0;

BMask = sparse(round(yy_bak),round(xx_bak),ones(1,length(xx_bak)),size(tem_img_rgb,1),size(tem_img_rgb,2));
BMask = (BMask -0.5)>0;
 
%%
obj_labels=splabels.*OMask;
bak_labels=splabels.*BMask;
objsuper_pixel_num=0;
baksuper_pixel_num=0;
olabel_list=[];
blabel_list=[];
Ho = zeros(max(max(splabels)),1);
Hb = zeros(max(max(splabels)),1);

for label_idx=1:max(max(splabels))
    temp_img1=(obj_labels==label_idx);
    temp_img2=(bak_labels==label_idx);
    pixel_num1=sum(sum(temp_img1));
    pixel_num2=sum(sum(temp_img2));
    if pixel_num1==0
        %obj_labels(obj_labels==label_idx)=0;
    else
        olabel_list=[olabel_list;label_idx];
        objsuper_pixel_num=objsuper_pixel_num+1;
        Ho(label_idx) = 1;
    end    
    if pixel_num2==0
        %bak_labels(bak_labels==label_idx)=0;
    else
        blabel_list=[blabel_list;label_idx];
        baksuper_pixel_num=baksuper_pixel_num+1;
        Hb(label_idx) = 1;
    end
end

%%
all_centers=[];
label_num=max(max(splabels));
for label_idx=1:label_num
    temp_img=(splabels==label_idx);
    stats=regionprops(bwlabel(temp_img),'basic');
    center_x=round(stats.Centroid(1));
    center_y=round(stats.Centroid(2));
    all_centers=[all_centers;[center_x,center_y]];
end

%%
K = 8;
[IDX,Dist] = knnsearch([all_centers(:,1) all_centers(:,2)],[all_centers(:,1) all_centers(:,2)],'K',K+1);
SP1 = repmat([IDX(:,1)'],1,K);
SP2 = [];
vec_dist = [];
for k=2:K+1
    SP2 = [SP2 IDX(:,k)'];
    vec_dist= [vec_dist Dist(:,k)'];
end

E = sparse(SP1,SP2,ones(length(SP2),1),label_num,label_num);
El = tril(E)+tril(E)';
Eu = triu(E)+triu(E)';
if sum(El(:))<=sum(Eu(:))
    E = El;
else 
    E = Eu;
end
clear Dist vec_dist;

%% compute intensity means of each superpixel for object template
vec_img_tem = zeros(max(max(splabels)),3*1);
tem_img_rgb = double(tem_img_rgb);
for super_pixel_idx=1:max(max(splabels))
    H = double(splabels==(super_pixel_idx));
    vec_img_tem(super_pixel_idx,1) = sum(sum(tem_img_rgb(:,:,1).*H))./(sum(sum(H)));
    vec_img_tem(super_pixel_idx,2) = sum(sum(tem_img_rgb(:,:,2).*H))./(sum(sum(H)));
    vec_img_tem(super_pixel_idx,3) = sum(sum(tem_img_rgb(:,:,3).*H))./(sum(sum(H)));
end

%%

if ~isempty(strfind(method,'CLP'))
    %disp('Preparing Proposed LP');
    [LL,objvs,ctime] = graph_edgeseg(all_centers,E,Ho,Hb,vec_img_tem,method,'MRF');
end

if ~isempty(strfind(method,'SLP'))
    %disp('Preparing Convetional LP');
    [LL,objvs,ctime] = seg_edgesLP(all_centers,E,Ho,Hb,vec_img_tem,'MRF');    
end

if ~isempty(strfind(method,'QP'))
    %disp('Preparing QP');
    [LL,objvs,ctime] = graph_edgeseg(all_centers,E,Ho,Hb,vec_img_tem,method,'MRF');
end

disp(['Ctime: ',num2str(ctime)]);

L = LL(:,end);

%%
H = zeros(size(splabels));
for label_idx=1:max(max(splabels))
    H=H+double(splabels==label_idx)*double(L(label_idx)>mean(L));    
end

labels = H;
labels1 = reshape(labels,size(splabels));

clearvars -except labels1 L ctime all_centers W Q;
